
; ================================================
;
;  FOR IC SOCKET U33 ON THE IBM 5150 MOTHERBOARD.
;
;  SIMPLY TO VERIFY THAT CERTAIN SIGNALS/DATA/ADDRESSES ARE REACHING THE 8253 TIMER CHIP.
;  WHEN RUN, THE SIGNALS/DATA/ADDRESS PINS OF THE 8253 WOULD BE EXAMINED USING A LOGIC ANALYSER.
;
;  COMPILE THIS CODE USING NASM 2.10 (OR LATER).
;
; ================================================

BITS 16

CPU 8086

ORG 0			; Offset 0 in ROM (i.e. address FE000 in IBM 5150 address space)

TIMES 0x1F00 DB 0	; Pad with zero to address 1F00h in ROM (i.e. address FFF00 in IBM 5150 address space)


; ----------------------------------------------------------------------------------------------
; CODE STARTS HERE, AT ADDRESS 1F00h in ROM (i.e. address FFF00 in IBM 5150 address space)
; ----------------------------------------------------------------------------------------------

	cli

loop1: 

	; Test address lines to 8253

	mov al,00h	; Data = 00
	out 40h,al	; 8253 address 0
	out 41h,al	; 8253 address 1
	out 42h,al	; 8253 address 2
	out 43h,al	; 8253 address 3

	; Test data lines to 8253

	mov al,00h	; Data = 00 {00000000}
	out 40h,al	; 8253 address 0
	mov al,0FFh	; Data = FF {11111111}
	out 40h,al	; 8253 address 0
	mov al,55h	; Data = 55 {01010101}
	out 40h,al	; 8253 address 0
	mov al,0AAh	; Data = AA {10101010}
	out 40h,al	; 8253 address 0
                          
	jmp loop1



TIMES 0x1FF0-($-$$) DB 0	; Pad out to reset vector

	jmp	0xFFF0:0000

TIMES 0x2000-($-$$) DB 0	; Pad out to end of ROM 





